#ifndef __DTK_COLOR_LEGEND_H__
#define __DTK_COLOR_LEGEND_H__


#include <gdk/gdk.h>
#include <gtk/gtkdrawingarea.h>

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */


#define DTK_TYPE_COLOR_LEGEND (dtk_color_legend_get_type ())
#define DTK_COLOR_LEGEND(obj) (GTK_CHECK_CAST((obj), DTK_TYPE_COLOR_LEGEND, DtkColorLegend))
#define DTK_COLOR_LEGEND_CLASS(klass) (GTK_CHECK_CLASS_CAST ((klass), DTK_TYPE_COLOR_LEGEND, DtkColorLegendClass))
#define DTK_IS_COLOR_LEGEND(obj) (GTK_CHECK_TYPE ((obj), DTK_TYPE_COLOR_LEGEND))
#define DKT_IS_COLOR_LEGEND_CLASS(klass)(GTK_CHECK_CLASS_TYPE ((klass), DTK_TYPE_COLOR_LEGEND))


typedef struct _DtkColorLegend       DtkColorLegend;
typedef struct _DtkColorLegendClass  DtkColorLegendClass;

struct _DtkColorLegend
{
  GtkDrawingArea area;
  GdkPixmap*pixmap;
  GdkGC*gc;
  gint num_colors;
  GdkColor*colors;
  gdouble*values;
  gchar*caption;
  gint precision;
  gint margin;
};

struct _DtkColorLegendClass
{
  GtkWidgetClass parent_class;
};

GtkType dtk_color_legend_get_type ();
GtkWidget*dtk_color_legend_new (gint num_colors, gint*colors);
void dtk_color_legend_set (DtkColorLegend*legend, gchar*caption, gdouble*values, gint precision);

#ifdef __cplusplus
}
#endif /* __cplusplus */


#endif /* __DTK_COLOR_LEGEND_H__ */

