#ifndef mu_ChangeWidget_h
#define mu_ChangeWidget_h

#include "mu_Widget.h"
#include "mu_Threadable.h"
#include "m3_defines.h"
#include "m3_WebClient.h"

#define MU_CHANGE_NUM_TYPES 4

typedef struct mu_ChangeType
{
  char*title;
  int type;
  char*name;
  GtkSignalFunc apply;
}mu_ChangeType;


class mu_ChangeWidget: public mu_Widget, public mu_Threadable
{
  public:
  private:
  int type;
  int address;
  int index;
  
  static mu_ChangeType types [MU_CHANGE_NUM_TYPES];
  m3_WebClient web;
  GtkWidget*boxes [MU_CHANGE_NUM_TYPES];
  GtkWidget*partRadios [MU_CHANGE_NUM_TYPES];
  GtkWidget*slotRadios [MU_CHANGE_NUM_TYPES];
  GtkWidget*switchRadios [MU_CHANGE_NUM_TYPES];
  GtkWidget*clusterRadios [MU_CHANGE_NUM_TYPES];
  GtkWidget*labels [MU_CHANGE_NUM_TYPES];
  GtkWidget*xbar16_sixteenth, *xbar16_quarter, *xbar16_one, *xbar16_four;
  GtkWidget*hssdc_internal, *hssdc_external, *hssdc_reset;
  GtkWidget*shortwave_internal, *shortwave_external, *shortwave_reset, *shortwave_laser;
  GtkWidget*xbarPort_slow, *xbarPort_off, *xbarPort_ha;  

  int lookup (int type);
  char*getChange (char*s, int type, int*cluster);
  
  public:
  
  mu_ChangeWidget ();
  int set (int address, int type, int index);
  void xbar16_run (void*);
  void xbarPort_run (void*);
  void hssdcPort_run (void*);
  void shortwaveFiberPort_run (void*);
  
};

#endif /*mu_ChangeWidget_h*/
