#ifndef mu_ExploreWidget_h
#define mu_ExploreWidget_h

#include "m3_RollcallClient.h"
#include "mm_Mapper.h"
#include "mt_MapperOptions.h"
#include "mt_MapperModule.h"
#include "mt_Calculator.h"
#include "mt_Network.h"
#include "mu_Threadable.h"
#include "m3_XbarTable.h"
#include "m3_SwitchFile.h"

#include "mu_Widget.h"

class mu_ExploreWidget : public mu_Widget, public mu_Threadable
{
  private:
  GtkWidget*fileSelection, *dirEntry;
  GtkWidget*runMapperCheckButton, *configureCheckButton, *findSwitchesCheckbox, *findXbarsCheckbox;
  GtkWidget*readHtmlCheckbox;
  GtkWidget*shortestPathCheckButton, *verboseCheckButton, *loopCheckButton;
  GtkWidget*writeRoutesCheckButton;
  GtkWidget*buildButton;
  
  m3_RollcallClient rollcall;
  m3_SwitchFile sf;
  mt_MapperModule*mapper;
  mt_MapperOptions mapperOptions;
  GtkWidget*makeDialogBox ();
  int setFileState (char*filename, char*directory, char*basename, GtkWidget*checkButton);
  int checkForWebFiles (int numAddresses, int*addresses);
  
  enum
  {
    FILENAME_LENGTH = 300
  };
  
  char mapFile [FILENAME_LENGTH];
  char hostsFile [FILENAME_LENGTH];
  char routesFile [FILENAME_LENGTH];
  char xbarFile [FILENAME_LENGTH];
  char switchFile [FILENAME_LENGTH];
  
  public:
  int*addresses;
  int numAddresses;
  m3_XbarTable*xbarTable;
  mt_Graph graph;
  mt_Network*network;
  mt_Calculator*calculator;
  static int setFilename (char*s, char*directory, char*base);
  void showFileSelection ()
  {
    gtk_widget_show (fileSelection);
  }
  void hideFileSelection ()
  {
    gtk_widget_hide (fileSelection);
  }
  mu_ExploreWidget ();
  void run (void*data);
  int setStates ();
  int getAddresses (int**addresses);
  void show ()
  {
    gtk_widget_grab_focus (buildButton);
    gtk_widget_show (widget);
  }
};


#endif /*mu_ExploreWidget_h*/
