#ifndef mu_FlashWidget_h
#define mu_FlashWidget_h

#include "mu_Widget.h"
#include "mu_Threadable.h"
#include "m3_SwitchFile.h"
#include "m3_TestClient.h"
#include "m3_RollcallClient.h"
#include "m3_Hex2Flash.h"
#include "m3_defines.h"

class mu_FlashVersion
{
  public:
  char version [M3_TEST_VERSION_STRING_LENGTH];
  char ethernetAddress [6];
};

class mu_FlashWidget : public mu_Widget, public mu_Threadable
{
  enum
  {
    FILENAME_LENGTH = 300
  };
  
  char switchFile [FILENAME_LENGTH];
  char flashFile [FILENAME_LENGTH];

  private:
  GtkWidget*list;
  GtkWidget*readButton,*findButton, *updateButton;
  GtkWidget*closeButton;
  GtkWidget*switchLabel, *flashLabel;
  m3_Hex2Flash hex2flash;
  m3_SwitchFile sf;
  m3_RollcallClient rollcall;
  m3_TestClient testClient;
  int*addresses;
  int numAddresses;
  mu_FlashVersion*versions;
  char versionString [M3_TEST_VERSION_STRING_LENGTH];
  int fillList ();
  int getVersions ();
  
  public:
  mu_FlashWidget ();
  void show ();
  void updateFilenames ();
  int readSwitches (void*data);
  int findSwitches (void*data);
  int updateFirmware (void*data);
};


#endif /*mu_FlashWidget_h*/
