
#include "mu_LegendWidget.h"
#include "mu_MainWidget.h"
#include "mu_ExploreWidget.h"
#include "insist.h"

#include "dtkcolorlegend.h"

extern mu_MainWidget*mu_mainWidget;

static void mu_LegendWidget_close (GtkWidget*w, mu_LegendWidget*widget)
{
  widget->hide ();
}

static gboolean mu_LegendWidget_delete (GtkWidget*w, GdkEvent*e, mu_LegendWidget*widget)
{
  widget->hide ();
  return 1;
}

static gboolean mu_LegendWidget_destroy (GtkWidget*w, mu_LegendWidget*widget)
{
  widget->hide ();
  return 0;
}


mu_LegendWidget::mu_LegendWidget (int numColors, int*colors)
{
  GtkWidget*box,*other,*button;
  
  insist (numColors > 0 && colors);
  
  widget = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  insist (widget);

  gtk_window_set_title (GTK_WINDOW (widget), MU_TITLE " - Legend");
  gtk_window_set_policy (GTK_WINDOW (widget), 1, 1, 0);
  gtk_widget_set_usize (widget, 150, 300);

  box = gtk_vbox_new (0, MU_SPACING);
  insist (box);
  gtk_container_add (GTK_CONTAINER (widget), box);
  gtk_widget_show (box);

  legend = dtk_color_legend_new (numColors, colors);
  insist (legend);
  gtk_widget_show (legend);
  gtk_box_pack_start (GTK_BOX (box), legend, 1, 1, MU_SPACING);

  
  other = gtk_hbox_new (0, MU_SPACING);
  insist (other);
  gtk_widget_show (other);
  gtk_box_pack_start (GTK_BOX (box), other, 0, 0, MU_SPACING);
  

  button = gtk_button_new_with_label ("Close");
  gtk_signal_connect (GTK_OBJECT (button), "clicked", GTK_SIGNAL_FUNC (mu_LegendWidget_close), this);

  gtk_signal_connect (GTK_OBJECT (widget), "delete_event", GTK_SIGNAL_FUNC (mu_LegendWidget_delete), this);
  gtk_signal_connect (GTK_OBJECT (widget), "destroy", GTK_SIGNAL_FUNC (mu_LegendWidget_destroy), this);

  gtk_widget_show (button);
  gtk_box_pack_start (GTK_BOX (other), button, 1, 0, MU_SPACING);

  exception:;
}


int mu_LegendWidget::set (char*caption, double*values, int precision)
{ 
  insist (this);
  insist (legend);
  
  dtk_color_legend_set (DTK_COLOR_LEGEND (legend), caption, values, precision);

  return 1;
  exception: return 0;
}
