#ifndef mu_OptionsWidget_h
#define mu_OptionsWidget_h

#include "mu_Widget.h"
#include "m3_defines.h"

class mu_OptionsWidget : public mu_Widget
{
  private:
  GtkWidget*workingDirectorySelection, *firmwareDirectorySelection;
  GtkWidget*workingDirectoryEntry, *firmwareDirectoryEntry;
  GtkWidget*eventToggles [M3_NUM_TRAPS];
  GtkAdjustment*maxThreadsAdjustment;
  GtkWidget*maxThreadsScale;
  GtkAdjustment*historyAdjustment;
  GtkWidget*historyScale;

  public:
  GtkWidget*logEventsToggle;
  
  void showWorkingDirectorySelection ()
  {
    gtk_widget_show (workingDirectorySelection);
  }
  void hideWorkingDirectorySelection ()
  {
    gtk_widget_hide (workingDirectorySelection);
  }
  void showFirmwareDirectorySelection ()
  {
    gtk_widget_show (firmwareDirectorySelection);
  }
  void hideFirmwareDirectorySelection ()
  {
    gtk_widget_hide (firmwareDirectorySelection);
  }
  mu_OptionsWidget ();
  void setWorkingDirectory ();
  void setFirmwareDirectory ();
  void writeOptions ();
  void readOptions ();
  int setEventToggles (int state);
};


#endif /*mu_OptionsWidget_h*/
