#ifndef mu_PacketWidget_h
#define mu_PacketWidget_h

#include "m3_TestClient.h"
#include "mu_Widget.h"
#include "mu_Threadable.h"


class mu_PacketHelper : public mu_Threadable
{
  private:
  m3_TestClient client;
  int address;
  mu_int64 good [M3_MAX_XBAR_PORT];
  mu_int64 bad [M3_MAX_XBAR_PORT];
  int swap (int count, m3_int64*from, mu_int64*to);

  public:
  void run (void*data);
};

class mu_PacketWidget : public mu_Widget, public mu_Threadable
{
  private:
  GtkWidget*goodRadio,*badRadio;
  GtkWidget*progressBar,*progressLabel;
  GtkWidget*startButton, *stopButton;
  int setLabel (GtkWidget*label, char*s, double d);
  mu_int64 goodTotalTotal, badTotalTotal;
  mu_int64 goodTotal, badTotal;
  mu_int64 goodMax, badMax, goodMin, badMin;
  int numSeen;
  int numAddresses;

  public:
  GtkWidget*goodTotalLabel, *goodTotalRateLabel, *goodMaxRateLabel, *badTotalLabel, *badTotalRateLabel, *badMaxRateLabel;

  mu_PacketWidget ();
  ~mu_PacketWidget ();
  void run (void*data);
  void eatCounters (int address, int numCounters, mu_int64*good, mu_int64*bad);
};


#endif /*mu_PacketWidget_h*/
