/*
  mu_Threadable.h
  thread hook.
  finucane@myri.com (David Finucane)
*/

#ifndef mu_Threadable_h
#define mu_Threadable_h

#include "gnome.h"
#include <stdio.h>
#include <stdlib.h>
#include <pthread.h>

class mu_Threadable;
typedef void (mu_Threadable::*mu_ThreadableFunction) (void*data);

class mu_Threadable
{
  private:
  enum
  {
    CREATED = 0,
    RUNNING = 1,
    STOPPED = 2
  };
  
  int state;
  pthread_t thread;
  pthread_mutex_t mutex;
  
  protected:
  int isStopped ();
  GtkWidget*threadText;
  void  sleep (int seconds);
  
  public:
  void*data;
  mu_ThreadableFunction function;
  void startThread ();
  
  mu_Threadable ();
  ~mu_Threadable ();
  int createThread (mu_ThreadableFunction function, void*data);
  int stopThread (int wait);
  int join ();
  virtual void printLine (char*s);
};

#endif /*mu_Threadable_h*/
