#include "insist.h"
#include "mt_Component.h"
#include "mu_WebWidget.h"

static gboolean mu_WebWidget_delete (GtkWidget*w, GdkEvent*e, mu_WebWidget*widget)
{
  widget->hide ();
  return 1;
}

static gboolean mu_WebWidget_destroy (GtkWidget*w, mu_WebWidget*widget)
{
  widget->hide ();
  return 0;
}

mu_WebWidget::mu_WebWidget ()
{
  GtkWidget*windowBox;
  widget = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  insist (widget);
  
  gtk_window_set_title (GTK_WINDOW (widget), MU_TITLE " - Port Info");
  gtk_window_set_policy (GTK_WINDOW (widget), 1, 1, 0);
  gtk_widget_set_usize (widget, 400, 650);

  windowBox = gtk_hbox_new (0, MU_SPACING);
  insist (windowBox);
  gtk_widget_show (windowBox);
  
  gtk_container_add (GTK_CONTAINER (widget), windowBox);

  gtk_signal_connect (GTK_OBJECT (widget), "delete_event", GTK_SIGNAL_FUNC (mu_WebWidget_delete), this);
  gtk_signal_connect (GTK_OBJECT (widget), "destroy", GTK_SIGNAL_FUNC (mu_WebWidget_destroy), this);

  threadText = gtk_text_new (0, 0);
  gtk_text_set_editable (GTK_TEXT (threadText), 0);
  gtk_box_pack_start (GTK_BOX (windowBox), threadText, 1, 1, MU_SPACING);
  gtk_widget_show (threadText);

  exception:;
}

int mu_WebWidget::get (char*server, int numPages, ...)
{
  va_list ap;

  insist (this && server);
  insist (numPages > 0 && numPages <= MU_WEB_WIDGET_MAX_PAGES);
  
  strncpy (this->server, server, M3_DISPLAY_STRING_LENGTH);
  this->numPages = numPages;
  
  va_start (ap, numPages);

  for (int i = 0; i < numPages; i++)
  {
    char*s = va_arg (ap, char*);
    strncpy (pages [i], s, M3_DISPLAY_STRING_LENGTH);
  }

  va_end (ap);

  show ();
  
  createThread ((mu_ThreadableFunction)&mu_WebWidget::run, 0);
  return 1;
  exception: return 0;
}

void mu_WebWidget::run (void*)
{
  insist (this && *server);
  insist (numPages > 0 && numPages <= MU_WEB_WIDGET_MAX_PAGES);

  char*s,*s1;
  
  for (int i = 0; i < numPages; i++)
  {
    if (!(s = web.get (server, pages [i])))
      return;

    for (int j = 0; j < 2; j++)
      while ((s = web.token ()) && strcmp (server, s));

    while (s = web.token ())
    {
      if (s1 = web.token ())
	mt_Component::printFormat ("%s %s", s, s1);
    }
    if (i < numPages - 1)
      mt_Component::printFormat ("");
  }
  
  exception:;
}
